
#include <pic.h>
#include "EDF09_1937.h"

void Initialize_CPU(void)
{

	ANSELA = 0x00 ;			// Disable All ADC input pin 
	ANSELB = 0x00 ;
	ANSELD = 0x00 ;
	PORTA = 0x00 ;			// Set all I/O pin is Low for LCD discharge.
	PORTB = 0x00 ;
	PORTC = 0x00 ;
	PORTD = 0x00 ;
	PORTE = 0x00 ;
	TRISA = 0x00;
	TRISB = 0x00;
	TRISC = 0x00;
	TRISD = 0x00;
	TRISE = 0x00;
	Delay_Second(2);
	
	ANSELA = 0x00 ;			// Disable All ADC input pin 
	ANSELB = 0x00 ;
	ANSELD = 0x00 ;
	ADCON1 = 0x50 ;			// Fosc/16

	TRISB4 = 0 ;	// output for COM0
	NOP();
	TRISB5 = 0 ;	// output for COM1
	NOP();
	TRISA2 = 0 ;	// output for COM2
	NOP();
	TRISD0 = 0 ;	// output for COM3
	NOP();
	
	TRISD1 = 1 ; 	// Input for SW5
	NOP();
	TRISD2 = 1 ; 	// Inout for SW6
	NOP();
//	TRISC6 = 0 ; 	// Output for LED6
//	NOP();
//	TRISC7 = 0 ; 	// Output for LED7
//	NOP();
	TRISB3 = 0 ; 	// Output for LED8
	NOP();

//	LED6_Off;		// Turn off LED6 ~ LED8
//	LED7_Off;
	LED8_Off;
}

void	Initialize_UART(void)
{
		TXSTA = 0b00100100 ;
		RCSTA = 0b10010000 ;
		SPBRG = 103 ;				// Ѧ Data Sheet k ,  FOSC = 32Mhz
		BRG16 = 0 ;					// SPBRG = 51 |o 19200  Baud Rate 
		RCIE = 1 ;					//  : BRGH = 1 
		TXIE = 0 ;					// SPBRG = (Fosc/Baud_Rate/16)-1

		TRISC6 = 0 ;				// TXD
		TRISC7 = 1 ;				// RXD 
}

// *************************************************************************************
// Function: CapInit()
// Purpose: Initialize the Capacitive Sense Module
// 			Initialize the Timer2 for 1mS interrupt
//          Initialize the Timer1 as CSM fequency Counter
// *************************************************************************************

void Cap_Init(void)
{	
		TRISB1 = 1; 				// Set AN10/CPS1 for the Input Fucntion			
 		ANSB1 = 1;					// Set AN10/CPS1 for the Analog Input (Data Sheet DS41364B-page 91)
 		CPSCON0 = 0b10001100;		// Cap sense On, High Range, T0 clock from Fosc/4
 		CPSCON1 = 0b00000001; 		// Select CPS1 channel; (Data Sheet DS41364B-page 180)
        
	// ********************************************************************************
	// Inititialize for Timer2 time base for the 1mS interrupt to measure the CSM 
	// frequency from Timer1
	// p Timer1 q쪺pƾȬ 315, h 315 x 1KHz = 315KHz
	// ********************************************************************************

		T2CON = 0b00001110;					// Postcaler 1:2, T2ON, Prescaler 1:16 
		PR2 = 249;							// Tcy 8MHz/250/2/16 = 1mS
		TMR2IF = 0;
		TMR2IE = 1;
	//
	// ]w Timer1  Clock Source Ӧ CSM Oscillator, ϥTimer1 _, Timer1 @­pƾ
	//
		T1CON  = 0b11000101;				// Timer1 enable, Capacitive Sensing Oscillator, 1:1 prescale, 
		T1GCON = 0b00000000;				// Timer1 is Counter, 
		TMR1GIF = 0;						// clear gate intpt flag
		TMR1GIE = 0;	 					// Disable gate intpt
 		TMR1H	= 0;						// reset Timer1
 		TMR1L	= 0;						//   "     "
		PEIE    = 1;						// enable peripheral intpts
		GIE 	= 1;
}

// ****************************************************************** 
// Function: Init_Timer4()
// Purpose: Initialize the Timer4 Module
// 			Set 5mS Interrupt for the key button scanning
// ****************************************************************** 

void Init_Timer4(void)
{
		T4CON = 0b01001111;					// Postcaler 1:64, T2ON, Prescaler 1:10 
		PR4 = 62;							// Tcy 8MHz/62/10/64 = 5mS
		TMR4IF = 0;
		TMR4IE = 1;
}