
#include <p18cxxx.h>
#include <timers.h>
#include <delays.h>

/* 	********************************************************************************
	PIC18F46J50_IO_Timer oӽmߥDnOnܽdb PIC18F46J50 pϥ Timer P
	{ӳW Timer , åBǷ|wƻPϥΤ_
	ϥΪ̥ib C:\mcc18\doc  PIC18F Peripheral Libraries  , 䤤
	Timer ]wξާ@Ƶ{ΥΪk

	{ :	ϥ OpenTimer1() N W Timer B@  
				ϥ WriteTimer1()ӳW ADC ModulegJ Timer1    
				ϥ #pragma code & #pragma interrupt ӦwƤ_{
		
				D^餣_Ū SW2 & SW3 䪺Gӧܦb Timer1 _nA
				 ! SW2 | LED1~LED4 ֱܧ ,  SW3 h|ܺC

	*******************************************************************************/


//  ********************************************************************************
//	ϥ MPLAB IDE  Help \ , b Help-> Topics iHU PIC18 MCU b{
//	p]w Configuration Bits 覡
//	********************************************************************************
     #pragma config WDTEN = OFF          //WDT disabled (enabled by SWDTEN bit)
     #pragma config PLLDIV = 3           //Divide by 3 (12 MHz oscillator input)
     #pragma config STVREN = ON          //stack overflow/underflow reset enabled
     #pragma config XINST = OFF          //Extended instruction set disabled
     #pragma config CPUDIV = OSC1        //No CPU system clock divide
     #pragma config CP0 = OFF            //Program memory is not code-protected
     #pragma config OSC = HSPLL          //HS oscillator, PLL enabled, HSPLL used by USB
     #pragma config T1DIG = OFF          //Sec Osc clock source may not be selected, unless T1OSCEN = 1
     #pragma config LPT1OSC = OFF        //high power Timer1 mode
     #pragma config FCMEN = OFF          //Fail-Safe Clock Monitor disabled
     #pragma config IESO = OFF           //Two-Speed Start-up disabled
     #pragma config WDTPS = 32768        //1:32768
     #pragma config DSWDTOSC = INTOSCREF //DSWDT uses INTOSC/INTRC as clock
     #pragma config RTCOSC = T1OSCREF    //RTCC uses T1OSC/T1CKI as clock
     #pragma config DSBOREN = OFF        //Zero-Power BOR disabled in Deep Sleep
     #pragma config DSWDTEN = OFF        //Disabled
     #pragma config DSWDTPS = 8192       //1:8,192 (8.5 seconds)
     #pragma config IOL1WAY = OFF        //IOLOCK bit can be set and cleared
     #pragma config MSSP7B_EN = MSK7     //7 Bit address masking
     #pragma config WPFP = PAGE_1        //Write Protect Program Flash Page 0
     #pragma config WPEND = PAGE_0       //Start protection at page 0
     #pragma config WPCFG = OFF          //Write/Erase last page protect Disabled
     #pragma config WPDIS = OFF          //WPFP[5:0], WPEND, and WPCFG bits ignored 

#define	LED1		LATBbits.LATB1
#define	LED2		LATBbits.LATB3
#define	LED3 		LATEbits.LATE0
#define LED4		LATEbits.LATE1
#define	DIR_LED1	TRISBbits.TRISB1
#define	DIR_LED2	TRISBbits.TRISB3
#define	DIR_LED3	TRISEbits.TRISE0 
#define	DIR_LED4	TRISEbits.TRISE1

#define	SW2			PORTBbits.RB0
#define	SW3			PORTBbits.RB2

#define	INPUT 		1
#define	OUTPUT		0

void	ISR_High(void) ;

unsigned char	LED_Number = 0 ;
unsigned		TIMER1_InitialVal = 0 ;

void	main(void)
{
	
	ANCON0 = 0b11111111 ;
	ANCON1 = 0b00011111 ;

	DIR_LED1 = OUTPUT ;
	DIR_LED2 = OUTPUT ;
	DIR_LED3 = OUTPUT ;
	DIR_LED4 = OUTPUT ;

	LED1 = 1 ;
	LED2 = 1 ;
	LED3 = 1 ;
	LED4 = 1 ;

	RCONbits.IPEN = 1 ;
	INTCONbits.GIE = 1 ;
	
	OpenTimer1(	TIMER_INT_ON&T1_16BIT_RW&T1_SOURCE_FOSC_4&
				T1_PS_1_8&T1_OSC1EN_OFF&T1_SYNC_EXT_OFF ,
				TIMER_GATE_OFF );

	WriteTimer1(0x0000) ;
	while(1) 
	{
		// Y SW2 , h Timer1 _lܤj , o˷|֦]Ӥ_		

		if (!SW2)									
			{
				if (TIMER1_InitialVal < 0xC000)
					TIMER1_InitialVal += 1000 ;
					Delay10KTCYx(10) ;
			}

		// Y SW3 , h Timer1 _lܤjp , o˷|ֺC]Ӥ_
		else if (!SW3)
				{
					if (TIMER1_InitialVal > 1000 )
						TIMER1_InitialVal -= 1000 ;
					else
						TIMER1_InitialVal = 0 ;
						Delay10KTCYx(10) ;
				}
	}	
}

#pragma code	ISRH_Vector = 0x0008
void 	isr_high_direct(void)	
{  								
     	_asm 			//begin in-line assembly
     	goto ISR_High	//go to ISR_High function
     	_endasm 		//end in-line assembly
}
#pragma code

/* ----------------------------------------------------------------
	_oͫnu@² , uOھ LED_Number oܼƨMw
	nG LED O LED1 ~ LED4 @ .
	p|y]OĪG
	_Aȵ{٦ӭI 
	(1)	_XnѳnM , _h_Lk
	(2) YO Overflow type  Timer (Ҧp Timer 1) , h̭pɪ
		DA ! _h 0 }l]
   ---------------------------------------------------------------*/
#pragma	interrupt	ISR_High
void	ISR_High(void)
{
		PIR1bits.TMR1IF = 0 ;

	WriteTimer1(TIMER1_InitialVal) ;
	switch (LED_Number)
	{
		case 0:
				LED1 = 1 ;
				LED2 = 0 ;
				LED3 = 0 ;
				LED4 = 0 ;
				LED_Number = 1 ;
				break ;
		case 1:
				LED1 = 0 ;
				LED2 = 1 ;
				LED3 = 0 ;
				LED4 = 0 ;
				LED_Number = 2 ;
				break ;
		case 2:
				LED1 = 0 ;
				LED2 = 0 ;
				LED3 = 1 ;
				LED4 = 0 ;
				LED_Number = 3 ;
				break ;
		case 3:
				LED1 = 0 ;
				LED2 = 0 ;
				LED3 = 0 ;
				LED4 = 1 ;
				LED_Number = 0 ;
				break ;
	}
}
#pragma code
