
#include <p18cxxx.h>
#include <pps.h>
#include <usart.h>
#include <delays.h>
#include <adc.h>
#include <stdlib.h>

/* 	********************************************************************************
	PIC18F46J50_UART_PPS oӽmߥDnOnܽdb PIC18F46J50 pϥ PPS P UART
	ϥΪ̥ib C:\mcc18\doc  PIC18F Peripheral Libraries  , 䤤
	PPS module P USART ]wξާ@Ƶ{ΥΪk

	{ :	ϥ iPPSOutput() NRP8 V U2TX \ 
				ϥ OpenADC()ӳW ADC Module   
				ϥ Open2USART() N USART2 W 19200,N,8,1 榡
				`N PIC18F46J50 \h\iH] Open Drain Control ..
					 pi 5V PX Voh
				
				D^餣_Ū ADC (VR1 @ RA5/AN4)  , ഫ ASCII rH
				":AXXXX"+0x0a,0x0d 榡eX

				ft APP-EDF01  PIC16F1937 Ѫd PIC16F1937_UART_LCD_Test      
				iHN ADC Gܩ APP-EDF09  LCD O
	*******************************************************************************/

#define	PIN_U2TX	LATBbits.LATB5 
#define	DIR_U2TX	TRISBbits.TRISB5	//	RB5/RP8 will be programmed as UART2 TX 
#define	LED1		LATBbits.LATB1		//	Use LED1 as USART2 Transmit indicator !! 
#define	DIR_LED1	TRISBbits.TRISB1

#define	OUTPUT		0
#define	INPUT		1

//  ********************************************************************************
//	ϥ MPLAB IDE  Help \ , b Help-> Topics iHU PIC18 MCU b{
//	p]w Configuration Bits 覡
//	********************************************************************************
     #pragma config WDTEN = OFF          //WDT disabled (enabled by SWDTEN bit)
     #pragma config PLLDIV = 3           //Divide by 3 (12 MHz oscillator input)
     #pragma config STVREN = ON          //stack overflow/underflow reset enabled
     #pragma config XINST = OFF          //Extended instruction set disabled
     #pragma config CPUDIV = OSC1        //No CPU system clock divide
     #pragma config CP0 = OFF            //Program memory is not code-protected
     #pragma config OSC = HSPLL          //HS oscillator, PLL enabled, HSPLL used by USB
     #pragma config T1DIG = OFF          //Sec Osc clock source may not be selected, unless T1OSCEN = 1
     #pragma config LPT1OSC = OFF        //high power Timer1 mode
     #pragma config FCMEN = OFF          //Fail-Safe Clock Monitor disabled
     #pragma config IESO = OFF           //Two-Speed Start-up disabled
     #pragma config WDTPS = 32768        //1:32768
     #pragma config DSWDTOSC = INTOSCREF //DSWDT uses INTOSC/INTRC as clock
     #pragma config RTCOSC = T1OSCREF    //RTCC uses T1OSC/T1CKI as clock
     #pragma config DSBOREN = OFF        //Zero-Power BOR disabled in Deep Sleep
     #pragma config DSWDTEN = OFF        //Disabled
     #pragma config DSWDTPS = 8192       //1:8,192 (8.5 seconds)
     #pragma config IOL1WAY = OFF        //IOLOCK bit can be set and cleared
     #pragma config MSSP7B_EN = MSK7     //7 Bit address masking
     #pragma config WPFP = PAGE_1        //Write Protect Program Flash Page 0
     #pragma config WPEND = PAGE_0       //Start protection at page 0
     #pragma config WPCFG = OFF          //Write/Erase last page protect Disabled
     #pragma config WPDIS = OFF          //WPFP[5:0], WPEND, and WPCFG bits ignored 

void	InitialUSART2(void) ;
void	InitialADC(void);

int				VR1_Value ;
unsigned char	VR1_Buf[10] ;

void	main(void)
{
	ANCON0 = 0b01101111 ;		// NҦP AD @Ϊ Pin We Digital 
	ANCON1 = 0b00011111 ;		// F AN4 (RA5)  VR , AN7(RE2)  MCP9701A
							
	InitialADC();
 	InitialUSART2();

	DIR_LED1 = OUTPUT ;
	
	while(1) 
	{
		SetChanADC(ADC_CH4) ;					//  AN4
		ConvertADC() ;							// _lഫ
		while(BusyADC()) ;						// ഫ
		
			VR1_Value = ReadADC() ;				// Ū ADC ȫഫ ":AXXXX"+0x0a+0x0d 
			itoa(VR1_Value,VR1_Buf) ;
			putc2USART(':') ;
			putc2USART('A') ;
			puts2USART(VR1_Buf) ;
			putrs2USART("\n\r");
			Delay10KTCYx(20) ;					//	{ݨӦq ..
			LED1 = ~LED1 ;						//  ϦV Transmit Indicator LED 
	}
	
}

void	InitialADC(void)
{
	OpenADC(ADC_FOSC_32&ADC_RIGHT_JUST&ADC_4_TAD,
			ADC_CH4&ADC_INT_OFF&ADC_REF_VDD_VSS,
			ADC_0ANA&ADC_VBG_OFF);
	 
	ANCON0bits.PCFG4 = 0 ;		//	AN4 W Analog Pin (VR)
	ANCON0bits.PCFG7 = 0 ;		//	AN7 W Analog Pin (MCP9701A)	

}

void	InitialUSART2(void)
{
	DIR_U2TX = OUTPUT ;
	
	iPPSOutput ( OUT_PIN_PPS_RP8,OUT_FN_PPS_TX2CK2 );	//	N UART2 TX \ RP8 (RB5)
	ODCON2bits.U2OD = 1 ;								//	N UART2 Open Drain \ Enable 
	//	--------------------------------------------------------------------------------------
	//	Per the formula in PIC18F46J50 data sheet ..
	// 	SPBRG = (Fosc/Baud_Rate/64)-1	-> BRGH=0 , BRG16=0
	// 	SPBRG = (Fosc/Baud_Rate/16)-1 	-> BRGH=1 , BRG16=0 
	//	SPBRG should be 155 .. However, only 38 (155/4) can works well and must check it out !
	//	--------------------------------------------------------------------------------------  
	Open2USART( USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &
            	USART_EIGHT_BIT   &
            	USART_CONT_RX     &
            	USART_BRGH_HIGH,
            	38                );
}
